/*************************************************************************
*									 *
*	 YAP Prolog 							 *
*									 *
*	Yap Prolog was developed at NCCUP - Universidade do Porto	 *
*									 *
* Copyright L.Damas, V.S.Costa and Universidade do Porto 1985-1997	 *
*									 *
**************************************************************************
*									 *
* File:		init.yap						 *
* Last rev:								 *
* mods:									 *
* comments:	initializing the full prolog system			 *
*									 *
*************************************************************************/

% This is yap's init file
% should be consulted first step after booting

% These are pseudo declarations
% so that the user will get a redefining system predicate
_ : _.
_ ; _.
_ | _.
_ -> _.
_ , _.
true :- true.
otherwise.
fail :- fail.
false :- false.
!.
\+ G :- \+ G.
not(G) :- not(G).
:- _ .
'$$!'(CP) :- '$cut_by'(CP).

:- '$set_value'($doindex,true).

:- 	['errors.yap',
	 'utils.yap',
	 'arith.yap'].

:- compile_expressions.


:- [	 'yio.yap',
	 'debug.yap',
	 'consult.yap',
	 'checker.yap',
	 'depth_bound.yap',
	 'grammar.yap',
	 'ground.yap',
	 'listing.yap',
	 'modules.yap',
	 'preds.yap',
	 'sockets.yap',
	 'sort.yap',
	 'setof.yap',
	 'tabling.yap',
	 'yapor.yap'].

:-	 ['protect.yap'].


version(yap,[4,1]).

system_mode(verbose,on)  :- '$set_value'('$verbose',on).
system_mode(verbose,off) :- '$set_value'('$verbose',off).

mode(_).

:- op(1150,fx,(mode)).

:- dynamic 'extensions_to_present_answer'/1.

:- 	['corout.yap',
	 'arrays.yap'].

:- '$change_type_of_char'(36,7). % Make $ a symbol character

:- default_sequential(off).

:- '$set_value'('$user_module',user), '$protect'.

:- style_check([]).

%
% moved this to init_gc in gc.c to separate the alpha
%
% :- yap_flag(gc,on).

% :- yap_flag(gc_trace,verbose).

:- system_mode(verbose,on).

:- dynamic term_expansion/2.

:- module(user).

:- dynamic library_directory/1.

:- get_value(system_library_directory,D), assert(library_directory(D)).



